<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/Dot.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/Dot.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/Dot.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-string">Uses 'dot' from graphviz to generate various graphs.</span></span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line12"></a><span class="lineno"> 12</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> *</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">from</span> Synopsis.QualifiedName <span class="py-keyword">import</span> *</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters <span class="py-keyword">import</span> TOC</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters <span class="py-keyword">import</span> quote_name, open_file</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-keyword">import</span> sys, os</span>
<a id="line19"></a><span class="lineno"> 19</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">verbose = False</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">debug = False</span>
<a id="line22"></a><span class="lineno"> 22</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/SystemError.html">SystemError</a>:</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Error thrown by the system() function. Attributes are 'retval', encoded</span></span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="py-string">   as per os.wait(): low-byte is killing signal number, high-byte is return</span></span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line"><span class="py-string">   value of command.&quot;&quot;&quot;</span></span>
<a id="line27"></a><span class="lineno"> 27</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/SystemError.html#__init__">__init__</a>(self, retval, command):</span>
<a id="line29"></a><span class="lineno"> 29</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">      self.retval = retval</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">      self.command = command</span>
<a id="line32"></a><span class="lineno"> 32</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/SystemError.html#__repr__">__repr__</a>(self):</span>
<a id="line34"></a><span class="lineno"> 34</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">      <span class="py-keyword">return</span> <span class="py-string">'SystemError: %(retval)x&quot;%(command)s&quot; failed.'</span>%self.__dict__</span>
<a id="line36"></a><span class="lineno"> 36</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line"><span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot.html#system">system</a>(command):</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Run the command. If the command fails, an exception SystemError is</span></span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line"><span class="py-string">   thrown.&quot;&quot;&quot;</span></span>
<a id="line40"></a><span class="lineno"> 40</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">   ret = os.system(command)</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">   <span class="py-keyword">if</span> (ret&gt;&gt;8) != 0:</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">      <span class="py-keyword">raise</span> SystemError(ret, command)</span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line"><span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot.html#normalize">normalize</a>(color):</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Generate a color triplet from a color string.&quot;&quot;&quot;</span></span>
<a id="line48"></a><span class="lineno"> 48</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">   <span class="py-keyword">if</span> type(color) <span class="py-keyword">is</span> str <span class="py-keyword">and</span> color[0] == <span class="py-string">'#'</span>:</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">      <span class="py-keyword">return</span> (int(color[1:3], 16), int(color[3:5], 16), int(color[5:7], 16))</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">   <span class="py-keyword">elif</span> type(color) <span class="py-keyword">is</span> tuple:</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">      <span class="py-keyword">return</span> (color[0] * 255, color[1] * 255, color[2] * 255)</span>
<a id="line53"></a><span class="lineno"> 53</span>
<a id="line54"></a><span class="lineno"> 54</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line"><span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot.html#light">light</a>(color):</span>
<a id="line56"></a><span class="lineno"> 56</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">   <span class="py-keyword">import</span> colorsys</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">   hsv = colorsys.rgb_to_hsv(*color)</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">   <span class="py-keyword">return</span> colorsys.hsv_to_rgb(hsv[0], hsv[1], hsv[2]/2)</span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/DotFileGenerator.html">DotFileGenerator</a>:</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">   <span class="py-string">&quot;&quot;&quot;A class that encapsulates the dot file generation&quot;&quot;&quot;</span></span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/DotFileGenerator.html#__init__">__init__</a>(self, os, direction, bgcolor):</span>
<a id="line65"></a><span class="lineno"> 65</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">      self.__os = os</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">      self.direction = direction</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">      self.bgcolor = bgcolor <span class="py-keyword">and</span> <span class="py-string">'&quot;#%X%X%X&quot;'</span>%bgcolor</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">      self.light_color = bgcolor <span class="py-keyword">and</span> <span class="py-string">'&quot;#%X%X%X&quot;'</span>%light(bgcolor) <span class="py-keyword">or</span> <span class="py-string">'gray75'</span></span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">      self.nodes = {}</span>
<a id="line71"></a><span class="lineno"> 71</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/DotFileGenerator.html#write">write</a>(self, text): self.__os.write(text)</span>
<a id="line73"></a><span class="lineno"> 73</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/DotFileGenerator.html#write_node">write_node</a>(self, ref, name, label, **attr):</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">      <span class="py-string">&quot;&quot;&quot;helper method to generate output for a given node&quot;&quot;&quot;</span></span>
<a id="line76"></a><span class="lineno"> 76</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">      <span class="py-keyword">if</span> self.nodes.has_key(name): <span class="py-keyword">return</span></span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">      self.nodes[name] = len(self.nodes)</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">      number = self.nodes[name]</span>
<a id="line80"></a><span class="lineno"> 80</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">      <span class="py-comment"># Quote to remove characters that dot can't handle</span></span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">      <span class="py-keyword">for</span> p <span class="py-keyword">in</span> [(<span class="py-string">'&lt;'</span>, <span class="py-string">'\&lt;'</span>), (<span class="py-string">'&gt;'</span>, <span class="py-string">'\&gt;'</span>), (<span class="py-string">'{'</span>,<span class="py-string">'\{'</span>), (<span class="py-string">'}'</span>,<span class="py-string">'\}'</span>)]:</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">         label = label.replace(*p)</span>
<a id="line84"></a><span class="lineno"> 84</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">      <span class="py-keyword">if</span> self.bgcolor:</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">         attr[<span class="py-string">'fillcolor'</span>] = self.bgcolor</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">         attr[<span class="py-string">'style'</span>] = <span class="py-string">'filled'</span></span>
<a id="line88"></a><span class="lineno"> 88</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">      self.write(<span class="py-string">&quot;Node&quot;</span> + str(number) + <span class="py-string">&quot; [shape=\&quot;record\&quot;, label=\&quot;{&quot;</span> + label + <span class="py-string">&quot;}\&quot;&quot;</span>)</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">      <span class="py-comment">#self.write(&quot;, fontSize = 10, height = 0.2, width = 0.4&quot;)</span></span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">      self.write(<span class="py-string">''</span>.join([<span class="py-string">', %s=%s'</span>%item <span class="py-keyword">for</span> item <span class="py-keyword">in</span> attr.items()]))</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">      <span class="py-keyword">if</span> ref: self.write(<span class="py-string">', URL=&quot;'</span> + ref + <span class="py-string">'&quot;'</span>)</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">      self.write(<span class="py-string">'];\n'</span>)</span>
<a id="line94"></a><span class="lineno"> 94</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/DotFileGenerator.html#write_edge">write_edge</a>(self, parent, child, **attr):</span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">      self.write(<span class="py-string">&quot;Node&quot;</span> + str(self.nodes[parent]) + <span class="py-string">&quot; -&gt; &quot;</span>)</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">      self.write(<span class="py-string">&quot;Node&quot;</span> + str(self.nodes[child]))</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">      self.write(<span class="py-string">'[ color=&quot;black&quot;, fontsize=10, dir=back'</span> + <span class="py-string">''</span>.join([<span class="py-string">', %s=&quot;%s&quot;'</span>%item <span class="py-keyword">for</span> item <span class="py-keyword">in</span> attr.items()]) + <span class="py-string">'];\n'</span>)</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html">InheritanceGenerator</a>(DotFileGenerator, ASG.Visitor):</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">   <span class="py-string">&quot;&quot;&quot;A Formatter that generates an inheritance graph. If the 'toc' argument is not None,</span></span>
<a id="line103"></a><span class="lineno">103</span><span class="line"><span class="py-string">   it is used to generate URLs. If no reference could be found in the toc, the node will</span></span>
<a id="line104"></a><span class="lineno">104</span><span class="line"><span class="py-string">   be grayed out.&quot;&quot;&quot;</span></span>
<a id="line105"></a><span class="lineno">105</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#__init__">__init__</a>(self, os, direction, operations, attributes, aggregation,</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">                toc, prefix, no_descend, bgcolor):</span>
<a id="line107"></a><span class="lineno">107</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">      DotFileGenerator.__init__(self, os, direction, bgcolor)</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">      <span class="py-keyword">if</span> operations: self.__operations = []</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">      <span class="py-keyword">else</span>: self.__operations = None</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">      <span class="py-keyword">if</span> attributes: self.__attributes = []</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">      <span class="py-keyword">else</span>: self.__attributes = None</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">      self.aggregation = aggregation</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">      self.toc = toc</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">      self.scope = QualifiedName()</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">      <span class="py-keyword">if</span> prefix:</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">         <span class="py-keyword">if</span> prefix.contains(<span class="py-string">'::'</span>):</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">            self.scope = QualifiedCxxName(prefix.split(<span class="py-string">'::'</span>))</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">         <span class="py-keyword">elif</span> prefix.contains(<span class="py-string">'.'</span>):</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">            self.scope = QualifiedPythonName(prefix.split(<span class="py-string">'.'</span>))</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">         <span class="py-keyword">else</span>:</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">            self.scope = QualifiedName((prefix,))</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">      self.__type_ref = None</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">      self.__type_label = <span class="py-string">''</span></span>
<a id="line125"></a><span class="lineno">125</span><span class="line">      self.__no_descend = no_descend</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">      self.nodes = {}</span>
<a id="line127"></a><span class="lineno">127</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#type_ref">type_ref</a>(self): <span class="py-keyword">return</span> self.__type_ref</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#type_label">type_label</a>(self): <span class="py-keyword">return</span> self.__type_label</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#parameter">parameter</a>(self): <span class="py-keyword">return</span> self.__parameter</span>
<a id="line131"></a><span class="lineno">131</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#format_type">format_type</a>(self, typeObj):</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">      <span class="py-string">&quot;Returns a reference string for the given type object&quot;</span></span>
<a id="line134"></a><span class="lineno">134</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">      <span class="py-keyword">if</span> typeObj <span class="py-keyword">is</span> None: <span class="py-keyword">return</span> <span class="py-string">&quot;(unknown)&quot;</span></span>
<a id="line136"></a><span class="lineno">136</span><span class="line">      typeObj.accept(self)</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">      <span class="py-keyword">return</span> self.type_label()</span>
<a id="line138"></a><span class="lineno">138</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#clear_type">clear_type</a>(self):</span>
<a id="line140"></a><span class="lineno">140</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">      self.__type_ref = None</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">      self.__type_label = <span class="py-string">''</span></span>
<a id="line143"></a><span class="lineno">143</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#get_class_name">get_class_name</a>(self, node):</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Returns the name of the given class node, relative to all its</span></span>
<a id="line146"></a><span class="lineno">146</span><span class="line"><span class="py-string">      parents. This makes the graph simpler by making the names shorter&quot;&quot;&quot;</span></span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">      base = node.name</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">      <span class="py-keyword">for</span> i <span class="py-keyword">in</span> node.parents:</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">         <span class="py-keyword">try</span>:</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">            parent = i.parent</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">            pname = parent.name</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">            <span class="py-keyword">for</span> j <span class="py-keyword">in</span> range(len(base)):</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">               <span class="py-keyword">if</span> j &gt; len(pname) <span class="py-keyword">or</span> pname[j] != base[j]:</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">                  <span class="py-comment"># Base is longer than parent name, or found a difference</span></span>
<a id="line156"></a><span class="lineno">156</span><span class="line">                  base[j:] = []</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">                  <span class="py-keyword">break</span></span>
<a id="line158"></a><span class="lineno">158</span><span class="line">         <span class="py-keyword">except</span>: <span class="py-keyword">pass</span> <span class="py-comment"># typedefs etc may cause errors here.. ignore</span></span>
<a id="line159"></a><span class="lineno">159</span><span class="line">      <span class="py-keyword">if</span> <span class="py-keyword">not</span> node.parents:</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">         base = self.scope</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">      <span class="py-keyword">return</span> str(self.scope.prune(node.name))</span>
<a id="line162"></a><span class="lineno">162</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">   <span class="py-comment">#################### Type Visitor ##########################################</span></span>
<a id="line164"></a><span class="lineno">164</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#visit_modifier_type">visit_modifier_type</a>(self, type):</span>
<a id="line166"></a><span class="lineno">166</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">      self.format_type(type.alias)</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">      self.__type_label = <span class="py-string">''</span>.join(type.premod) + self.__type_label</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">      self.__type_label = self.__type_label + <span class="py-string">''</span>.join(type.postmod)</span>
<a id="line170"></a><span class="lineno">170</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#visit_unknown_type">visit_unknown_type</a>(self, type):</span>
<a id="line172"></a><span class="lineno">172</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">      self.__type_ref = self.toc <span class="py-keyword">and</span> self.toc[type.link] <span class="py-keyword">or</span> None</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">      self.__type_label = str(self.scope.prune(type.name))</span>
<a id="line175"></a><span class="lineno">175</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#visit_builtin_type_id">visit_builtin_type_id</a>(self, type):</span>
<a id="line177"></a><span class="lineno">177</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">      self.__type_ref = None</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">      self.__type_label = type.name[-1]</span>
<a id="line180"></a><span class="lineno">180</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#visit_dependent_type_id">visit_dependent_type_id</a>(self, type):</span>
<a id="line182"></a><span class="lineno">182</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">      self.__type_ref = None</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">      self.__type_label = type.name[-1]</span>
<a id="line185"></a><span class="lineno">185</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#visit_declared_type_id">visit_declared_type_id</a>(self, type):</span>
<a id="line187"></a><span class="lineno">187</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">      self.__type_ref = self.toc <span class="py-keyword">and</span> self.toc[type.declaration.name] <span class="py-keyword">or</span> None</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">      <span class="py-keyword">if</span> isinstance(type.declaration, ASG.Class):</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">         self.__type_label = self.get_class_name(type.declaration)</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line192"></a><span class="lineno">192</span><span class="line">         self.__type_label = str(self.scope.prune(type.declaration.name))</span>
<a id="line193"></a><span class="lineno">193</span>
<a id="line194"></a><span class="lineno">194</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#visit_parametrized_type_id">visit_parametrized_type_id</a>(self, type):</span>
<a id="line195"></a><span class="lineno">195</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">      <span class="py-keyword">if</span> type.template:</span>
<a id="line197"></a><span class="lineno">197</span><span class="line">         type_ref = self.toc <span class="py-keyword">and</span> self.toc[type.template.name] <span class="py-keyword">or</span> None</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">         type_label = str(self.scope.prune(type.template.name))</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">         type_ref = None</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">         type_label = <span class="py-string">&quot;(unknown)&quot;</span></span>
<a id="line202"></a><span class="lineno">202</span><span class="line">      parameters_label = []</span>
<a id="line203"></a><span class="lineno">203</span><span class="line">      <span class="py-keyword">for</span> p <span class="py-keyword">in</span> type.parameters:</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">         parameters_label.append(self.format_type(p))</span>
<a id="line205"></a><span class="lineno">205</span><span class="line">      self.__type_ref = type_ref</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">      self.__type_label = type_label + <span class="py-string">&quot;&lt;&quot;</span> + <span class="py-string">','</span>.join(parameters_label) + <span class="py-string">&quot;&gt;&quot;</span></span>
<a id="line207"></a><span class="lineno">207</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#visit_template_id">visit_template_id</a>(self, type):</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">      self.__type_ref = None</span>
<a id="line210"></a><span class="lineno">210</span><span class="line">      <span class="py-keyword">def</span> clip(x, max=20):</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">         <span class="py-keyword">if</span> len(x) &gt; max: <span class="py-keyword">return</span> <span class="py-string">'...'</span></span>
<a id="line212"></a><span class="lineno">212</span><span class="line">         <span class="py-keyword">return</span> x</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">      self.__type_label = <span class="py-string">&quot;template&lt;%s&gt;&quot;</span>%(clip(<span class="py-string">','</span>.join([clip(self.format_type(p)) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> type.parameters]), 40))</span>
<a id="line214"></a><span class="lineno">214</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">   <span class="py-comment">#################### ASG Visitor ###########################################</span></span>
<a id="line216"></a><span class="lineno">216</span>
<a id="line217"></a><span class="lineno">217</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#visit_inheritance">visit_inheritance</a>(self, node):</span>
<a id="line218"></a><span class="lineno">218</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">      self.format_type(node.parent)</span>
<a id="line220"></a><span class="lineno">220</span><span class="line">      <span class="py-keyword">if</span> self.type_ref():</span>
<a id="line221"></a><span class="lineno">221</span><span class="line">         self.write_node(self.type_ref().link, self.type_label(), self.type_label())</span>
<a id="line222"></a><span class="lineno">222</span><span class="line">      <span class="py-keyword">elif</span> self.toc:</span>
<a id="line223"></a><span class="lineno">223</span><span class="line">         self.write_node(<span class="py-string">''</span>, self.type_label(), self.type_label(), color=self.light_color, fontcolor=self.light_color)</span>
<a id="line224"></a><span class="lineno">224</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line225"></a><span class="lineno">225</span><span class="line">         self.write_node(<span class="py-string">''</span>, self.type_label(), self.type_label())</span>
<a id="line226"></a><span class="lineno">226</span>
<a id="line227"></a><span class="lineno">227</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#visit_class">visit_class</a>(self, node):</span>
<a id="line228"></a><span class="lineno">228</span>
<a id="line229"></a><span class="lineno">229</span><span class="line">      <span class="py-keyword">if</span> self.__operations <span class="py-keyword">is</span> <span class="py-keyword">not</span> None: self.__operations.append([])</span>
<a id="line230"></a><span class="lineno">230</span><span class="line">      <span class="py-keyword">if</span> self.__attributes <span class="py-keyword">is</span> <span class="py-keyword">not</span> None: self.__attributes.append([])</span>
<a id="line231"></a><span class="lineno">231</span><span class="line">      name = self.get_class_name(node)</span>
<a id="line232"></a><span class="lineno">232</span><span class="line">      ref = self.toc <span class="py-keyword">and</span> self.toc[node.name] <span class="py-keyword">or</span> None</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">      <span class="py-keyword">for</span> d <span class="py-keyword">in</span> node.declarations: d.accept(self)</span>
<a id="line234"></a><span class="lineno">234</span><span class="line">      <span class="py-comment"># NB: old version of dot needed the label surrounded in {}'s (?)</span></span>
<a id="line235"></a><span class="lineno">235</span><span class="line">      label = name</span>
<a id="line236"></a><span class="lineno">236</span><span class="line">      <span class="py-keyword">if</span> type(node) <span class="py-keyword">is</span> ASG.ClassTemplate <span class="py-keyword">and</span> node.template:</span>
<a id="line237"></a><span class="lineno">237</span><span class="line">         <span class="py-keyword">if</span> self.direction == <span class="py-string">'vertical'</span>:</span>
<a id="line238"></a><span class="lineno">238</span><span class="line">            label = self.format_type(node.template) + <span class="py-string">'\\n'</span> + label</span>
<a id="line239"></a><span class="lineno">239</span><span class="line">         <span class="py-keyword">else</span>:</span>
<a id="line240"></a><span class="lineno">240</span><span class="line">            label = self.format_type(node.template) + <span class="py-string">' '</span> + label</span>
<a id="line241"></a><span class="lineno">241</span><span class="line">      <span class="py-keyword">if</span> self.__operations <span class="py-keyword">or</span> self.__attributes:</span>
<a id="line242"></a><span class="lineno">242</span><span class="line">         label = label + <span class="py-string">'\\n'</span></span>
<a id="line243"></a><span class="lineno">243</span><span class="line">         <span class="py-keyword">if</span> self.__operations:</span>
<a id="line244"></a><span class="lineno">244</span><span class="line">            label += <span class="py-string">'|'</span> + <span class="py-string">''</span>.join([x[-1] + <span class="py-string">'()\\l'</span> <span class="py-keyword">for</span> x <span class="py-keyword">in</span> self.__operations[-1]])</span>
<a id="line245"></a><span class="lineno">245</span><span class="line">         <span class="py-keyword">if</span> self.__attributes:</span>
<a id="line246"></a><span class="lineno">246</span><span class="line">            label += <span class="py-string">'|'</span> + <span class="py-string">''</span>.join([x[-1] + <span class="py-string">'\\l'</span> <span class="py-keyword">for</span> x <span class="py-keyword">in</span> self.__attributes[-1]])</span>
<a id="line247"></a><span class="lineno">247</span><span class="line">      <span class="py-keyword">if</span> ref:</span>
<a id="line248"></a><span class="lineno">248</span><span class="line">         self.write_node(ref.link, name, label)</span>
<a id="line249"></a><span class="lineno">249</span><span class="line">      <span class="py-keyword">elif</span> self.toc:</span>
<a id="line250"></a><span class="lineno">250</span><span class="line">         self.write_node(<span class="py-string">''</span>, name, label, color=self.light_color, fontcolor=self.light_color)</span>
<a id="line251"></a><span class="lineno">251</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line252"></a><span class="lineno">252</span><span class="line">         self.write_node(<span class="py-string">''</span>, name, label)</span>
<a id="line253"></a><span class="lineno">253</span>
<a id="line254"></a><span class="lineno">254</span><span class="line">      <span class="py-keyword">if</span> self.aggregation:</span>
<a id="line255"></a><span class="lineno">255</span><span class="line">         <span class="py-comment">#FIXME: we shouldn't only be looking for variables of the exact type,</span></span>
<a id="line256"></a><span class="lineno">256</span><span class="line">         <span class="py-comment">#       but also derived types such as pointers, references, STL containers, etc.</span></span>
<a id="line257"></a><span class="lineno">257</span><span class="line">         <span class="py-comment">#</span></span>
<a id="line258"></a><span class="lineno">258</span><span class="line">         <span class="py-comment"># find attributes of type 'Class' so we can link to it</span></span>
<a id="line259"></a><span class="lineno">259</span><span class="line">         <span class="py-keyword">for</span> a <span class="py-keyword">in</span> filter(<span class="py-keyword">lambda</span> a:isinstance(a, ASG.Variable), node.declarations):</span>
<a id="line260"></a><span class="lineno">260</span><span class="line">            <span class="py-keyword">if</span> isinstance(a.vtype, ASG.DeclaredTypeId):</span>
<a id="line261"></a><span class="lineno">261</span><span class="line">               d = a.vtype.declaration</span>
<a id="line262"></a><span class="lineno">262</span><span class="line">               <span class="py-keyword">if</span> isinstance(d, ASG.Class) <span class="py-keyword">and</span> self.nodes.has_key(self.get_class_name(d)):</span>
<a id="line263"></a><span class="lineno">263</span><span class="line">                  self.write_edge(self.get_class_name(node), self.get_class_name(d),</span>
<a id="line264"></a><span class="lineno">264</span><span class="line">                                  arrowtail=<span class="py-string">'ediamond'</span>)</span>
<a id="line265"></a><span class="lineno">265</span>
<a id="line266"></a><span class="lineno">266</span><span class="line">      <span class="py-keyword">for</span> p <span class="py-keyword">in</span> node.parents:</span>
<a id="line267"></a><span class="lineno">267</span><span class="line">         p.accept(self)</span>
<a id="line268"></a><span class="lineno">268</span><span class="line">         self.write_edge(self.type_label(), name, arrowtail=<span class="py-string">'empty'</span>)</span>
<a id="line269"></a><span class="lineno">269</span><span class="line">      <span class="py-keyword">if</span> self.__no_descend: <span class="py-keyword">return</span></span>
<a id="line270"></a><span class="lineno">270</span><span class="line">      <span class="py-keyword">if</span> self.__operations: self.__operations.pop()</span>
<a id="line271"></a><span class="lineno">271</span><span class="line">      <span class="py-keyword">if</span> self.__attributes: self.__attributes.pop()</span>
<a id="line272"></a><span class="lineno">272</span>
<a id="line273"></a><span class="lineno">273</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#visit_operation">visit_operation</a>(self, operation):</span>
<a id="line274"></a><span class="lineno">274</span>
<a id="line275"></a><span class="lineno">275</span><span class="line">      <span class="py-keyword">if</span> self.__operations:</span>
<a id="line276"></a><span class="lineno">276</span><span class="line">         self.__operations[-1].append(operation.real_name)</span>
<a id="line277"></a><span class="lineno">277</span>
<a id="line278"></a><span class="lineno">278</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/InheritanceGenerator.html#visit_variable">visit_variable</a>(self, variable):</span>
<a id="line279"></a><span class="lineno">279</span>
<a id="line280"></a><span class="lineno">280</span><span class="line">      <span class="py-keyword">if</span> self.__attributes:</span>
<a id="line281"></a><span class="lineno">281</span><span class="line">         self.__attributes[-1].append(variable.name)</span>
<a id="line282"></a><span class="lineno">282</span>
<a id="line283"></a><span class="lineno">283</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/SingleInheritanceGenerator.html">SingleInheritanceGenerator</a>(InheritanceGenerator):</span>
<a id="line284"></a><span class="lineno">284</span><span class="line">   <span class="py-string">&quot;&quot;&quot;A Formatter that generates an inheritance graph for a specific class.</span></span>
<a id="line285"></a><span class="lineno">285</span><span class="line"><span class="py-string">   This Visitor visits the ASG upwards, i.e. following the inheritance links, instead of</span></span>
<a id="line286"></a><span class="lineno">286</span><span class="line"><span class="py-string">   the declarations contained in a given scope.&quot;&quot;&quot;</span></span>
<a id="line287"></a><span class="lineno">287</span>
<a id="line288"></a><span class="lineno">288</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/SingleInheritanceGenerator.html#__init__">__init__</a>(self, os, direction, operations, attributes, levels, types,</span>
<a id="line289"></a><span class="lineno">289</span><span class="line">                toc, prefix, no_descend, bgcolor):</span>
<a id="line290"></a><span class="lineno">290</span><span class="line">      InheritanceGenerator.__init__(self, os, direction, operations, attributes, False,</span>
<a id="line291"></a><span class="lineno">291</span><span class="line">                                    toc, prefix, no_descend, bgcolor)</span>
<a id="line292"></a><span class="lineno">292</span><span class="line">      self.__levels = levels</span>
<a id="line293"></a><span class="lineno">293</span><span class="line">      self.__types = types</span>
<a id="line294"></a><span class="lineno">294</span><span class="line">      self.__current = 1</span>
<a id="line295"></a><span class="lineno">295</span><span class="line">      self.__visited_classes = {} <span class="py-comment"># classes already visited, to prevent recursion</span></span>
<a id="line296"></a><span class="lineno">296</span>
<a id="line297"></a><span class="lineno">297</span><span class="line">   <span class="py-comment">#################### Type Visitor ##########################################</span></span>
<a id="line298"></a><span class="lineno">298</span>
<a id="line299"></a><span class="lineno">299</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/SingleInheritanceGenerator.html#visit_declared_type_id">visit_declared_type_id</a>(self, type):</span>
<a id="line300"></a><span class="lineno">300</span><span class="line">      <span class="py-keyword">if</span> self.__current &lt; self.__levels <span class="py-keyword">or</span> self.__levels == -1:</span>
<a id="line301"></a><span class="lineno">301</span><span class="line">         self.__current = self.__current + 1</span>
<a id="line302"></a><span class="lineno">302</span><span class="line">         type.declaration.accept(self)</span>
<a id="line303"></a><span class="lineno">303</span><span class="line">         self.__current = self.__current - 1</span>
<a id="line304"></a><span class="lineno">304</span><span class="line">      <span class="py-comment"># to restore the ref/label...</span></span>
<a id="line305"></a><span class="lineno">305</span><span class="line">      InheritanceGenerator.visit_declared_type_id(self, type)</span>
<a id="line306"></a><span class="lineno">306</span>
<a id="line307"></a><span class="lineno">307</span><span class="line">   <span class="py-comment">#################### ASG Visitor ###########################################</span></span>
<a id="line308"></a><span class="lineno">308</span>
<a id="line309"></a><span class="lineno">309</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/SingleInheritanceGenerator.html#visit_inheritance">visit_inheritance</a>(self, node):</span>
<a id="line310"></a><span class="lineno">310</span>
<a id="line311"></a><span class="lineno">311</span><span class="line">      node.parent.accept(self)</span>
<a id="line312"></a><span class="lineno">312</span><span class="line">      <span class="py-keyword">if</span> self.type_label():</span>
<a id="line313"></a><span class="lineno">313</span><span class="line">         <span class="py-keyword">if</span> self.type_ref():</span>
<a id="line314"></a><span class="lineno">314</span><span class="line">            self.write_node(self.type_ref().link, self.type_label(), self.type_label())</span>
<a id="line315"></a><span class="lineno">315</span><span class="line">         <span class="py-keyword">elif</span> self.toc:</span>
<a id="line316"></a><span class="lineno">316</span><span class="line">            self.write_node(<span class="py-string">''</span>, self.type_label(), self.type_label(), color=self.light_color, fontcolor=self.light_color)</span>
<a id="line317"></a><span class="lineno">317</span><span class="line">         <span class="py-keyword">else</span>:</span>
<a id="line318"></a><span class="lineno">318</span><span class="line">            self.write_node(<span class="py-string">''</span>, self.type_label(), self.type_label())</span>
<a id="line319"></a><span class="lineno">319</span>
<a id="line320"></a><span class="lineno">320</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/SingleInheritanceGenerator.html#visit_class">visit_class</a>(self, node):</span>
<a id="line321"></a><span class="lineno">321</span>
<a id="line322"></a><span class="lineno">322</span><span class="line">      <span class="py-comment"># Prevent recursion</span></span>
<a id="line323"></a><span class="lineno">323</span><span class="line">      <span class="py-keyword">if</span> self.__visited_classes.has_key(id(node)): <span class="py-keyword">return</span></span>
<a id="line324"></a><span class="lineno">324</span><span class="line">      self.__visited_classes[id(node)] = None</span>
<a id="line325"></a><span class="lineno">325</span>
<a id="line326"></a><span class="lineno">326</span><span class="line">      name = self.get_class_name(node)</span>
<a id="line327"></a><span class="lineno">327</span><span class="line">      <span class="py-keyword">if</span> self.__current == 1:</span>
<a id="line328"></a><span class="lineno">328</span><span class="line">         self.write_node(<span class="py-string">''</span>, name, name, style=<span class="py-string">'filled'</span>, color=self.light_color, fontcolor=self.light_color)</span>
<a id="line329"></a><span class="lineno">329</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line330"></a><span class="lineno">330</span><span class="line">         ref = self.toc <span class="py-keyword">and</span> self.toc[node.name] <span class="py-keyword">or</span> None</span>
<a id="line331"></a><span class="lineno">331</span><span class="line">         <span class="py-keyword">if</span> ref:</span>
<a id="line332"></a><span class="lineno">332</span><span class="line">            self.write_node(ref.link, name, name)</span>
<a id="line333"></a><span class="lineno">333</span><span class="line">         <span class="py-keyword">elif</span> self.toc:</span>
<a id="line334"></a><span class="lineno">334</span><span class="line">            self.write_node(<span class="py-string">''</span>, name, name, color=self.light_color, fontcolor=self.light_color)</span>
<a id="line335"></a><span class="lineno">335</span><span class="line">         <span class="py-keyword">else</span>:</span>
<a id="line336"></a><span class="lineno">336</span><span class="line">            self.write_node(<span class="py-string">''</span>, name, name)</span>
<a id="line337"></a><span class="lineno">337</span>
<a id="line338"></a><span class="lineno">338</span><span class="line">      <span class="py-keyword">for</span> p <span class="py-keyword">in</span> node.parents:</span>
<a id="line339"></a><span class="lineno">339</span><span class="line">         p.accept(self)</span>
<a id="line340"></a><span class="lineno">340</span><span class="line">         <span class="py-keyword">if</span> self.nodes.has_key(self.type_label()):</span>
<a id="line341"></a><span class="lineno">341</span><span class="line">            self.write_edge(self.type_label(), name, arrowtail=<span class="py-string">'empty'</span>)</span>
<a id="line342"></a><span class="lineno">342</span><span class="line">      <span class="py-comment"># if this is the main class and if there is a type dictionary,</span></span>
<a id="line343"></a><span class="lineno">343</span><span class="line">      <span class="py-comment"># look for classes that are derived from this class</span></span>
<a id="line344"></a><span class="lineno">344</span>
<a id="line345"></a><span class="lineno">345</span><span class="line">      <span class="py-comment"># if this is the main class</span></span>
<a id="line346"></a><span class="lineno">346</span><span class="line">      <span class="py-keyword">if</span> self.__current == 1 <span class="py-keyword">and</span> self.__types:</span>
<a id="line347"></a><span class="lineno">347</span><span class="line">         <span class="py-comment"># fool the visit_declared_type_id method to stop walking upwards</span></span>
<a id="line348"></a><span class="lineno">348</span><span class="line">         self.__levels = 0</span>
<a id="line349"></a><span class="lineno">349</span><span class="line">         <span class="py-keyword">for</span> t <span class="py-keyword">in</span> self.__types.values():</span>
<a id="line350"></a><span class="lineno">350</span><span class="line">            <span class="py-keyword">if</span> isinstance(t, ASG.DeclaredTypeId):</span>
<a id="line351"></a><span class="lineno">351</span><span class="line">               child = t.declaration</span>
<a id="line352"></a><span class="lineno">352</span><span class="line">               <span class="py-keyword">if</span> isinstance(child, ASG.Class):</span>
<a id="line353"></a><span class="lineno">353</span><span class="line">                  <span class="py-keyword">for</span> i <span class="py-keyword">in</span> child.parents:</span>
<a id="line354"></a><span class="lineno">354</span><span class="line">                     type = i.parent</span>
<a id="line355"></a><span class="lineno">355</span><span class="line">                     type.accept(self)</span>
<a id="line356"></a><span class="lineno">356</span><span class="line">                     <span class="py-keyword">if</span> self.type_ref():</span>
<a id="line357"></a><span class="lineno">357</span><span class="line">                        <span class="py-keyword">if</span> self.type_ref().name == node.name:</span>
<a id="line358"></a><span class="lineno">358</span><span class="line">                           child_label = self.get_class_name(child)</span>
<a id="line359"></a><span class="lineno">359</span><span class="line">                           ref = self.toc <span class="py-keyword">and</span> self.toc[child.name] <span class="py-keyword">or</span> None</span>
<a id="line360"></a><span class="lineno">360</span><span class="line">                           <span class="py-keyword">if</span> ref:</span>
<a id="line361"></a><span class="lineno">361</span><span class="line">                              self.write_node(ref.link, child_label, child_label)</span>
<a id="line362"></a><span class="lineno">362</span><span class="line">                           <span class="py-keyword">elif</span> self.toc:</span>
<a id="line363"></a><span class="lineno">363</span><span class="line">                              self.write_node(<span class="py-string">''</span>, child_label, child_label, color=self.light_color, fontcolor=self.light_color)</span>
<a id="line364"></a><span class="lineno">364</span><span class="line">                           <span class="py-keyword">else</span>:</span>
<a id="line365"></a><span class="lineno">365</span><span class="line">                              self.write_node(<span class="py-string">''</span>, child_label, child_label)</span>
<a id="line366"></a><span class="lineno">366</span>
<a id="line367"></a><span class="lineno">367</span><span class="line">                           self.write_edge(name, child_label, arrowtail=<span class="py-string">'empty'</span>)</span>
<a id="line368"></a><span class="lineno">368</span>
<a id="line369"></a><span class="lineno">369</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/FileDependencyGenerator.html">FileDependencyGenerator</a>(DotFileGenerator, ASG.Visitor):</span>
<a id="line370"></a><span class="lineno">370</span><span class="line">   <span class="py-string">&quot;&quot;&quot;A Formatter that generates a file dependency graph&quot;&quot;&quot;</span></span>
<a id="line371"></a><span class="lineno">371</span>
<a id="line372"></a><span class="lineno">372</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/FileDependencyGenerator.html#visit_file">visit_file</a>(self, file):</span>
<a id="line373"></a><span class="lineno">373</span><span class="line">      <span class="py-keyword">if</span> file.annotations[<span class="py-string">'primary'</span>]:</span>
<a id="line374"></a><span class="lineno">374</span><span class="line">         self.write_node(<span class="py-string">''</span>, file.name, file.name)</span>
<a id="line375"></a><span class="lineno">375</span><span class="line">      <span class="py-keyword">for</span> i <span class="py-keyword">in</span> file.includes:</span>
<a id="line376"></a><span class="lineno">376</span><span class="line">         target = i.target</span>
<a id="line377"></a><span class="lineno">377</span><span class="line">         <span class="py-keyword">if</span> target.annotations[<span class="py-string">'primary'</span>]:</span>
<a id="line378"></a><span class="lineno">378</span><span class="line">            self.write_node(<span class="py-string">''</span>, target.name, target.name)</span>
<a id="line379"></a><span class="lineno">379</span><span class="line">            name = i.name</span>
<a id="line380"></a><span class="lineno">380</span><span class="line">            name = name.replace(<span class="py-string">'&quot;'</span>, <span class="py-string">'\\&quot;'</span>)</span>
<a id="line381"></a><span class="lineno">381</span><span class="line">            self.write_edge(target.name, file.name, label=name, style=<span class="py-string">'dashed'</span>)</span>
<a id="line382"></a><span class="lineno">382</span>
<a id="line383"></a><span class="lineno">383</span><span class="line"><span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot.html#_rel">_rel</a>(frm, to):</span>
<a id="line384"></a><span class="lineno">384</span><span class="line">   <span class="py-string">&quot;Find link to to relative to frm&quot;</span></span>
<a id="line385"></a><span class="lineno">385</span>
<a id="line386"></a><span class="lineno">386</span><span class="line">   frm = frm.split(<span class="py-string">'/'</span>); to = to.split(<span class="py-string">'/'</span>)</span>
<a id="line387"></a><span class="lineno">387</span><span class="line">   <span class="py-keyword">for</span> l <span class="py-keyword">in</span> range((len(frm)&lt;len(to)) <span class="py-keyword">and</span> len(frm)-1 <span class="py-keyword">or</span> len(to)-1):</span>
<a id="line388"></a><span class="lineno">388</span><span class="line">      <span class="py-keyword">if</span> to[0] == frm[0]: <span class="py-keyword">del</span> to[0]; <span class="py-keyword">del</span> frm[0]</span>
<a id="line389"></a><span class="lineno">389</span><span class="line">      <span class="py-keyword">else</span>: <span class="py-keyword">break</span></span>
<a id="line390"></a><span class="lineno">390</span><span class="line">   <span class="py-keyword">if</span> frm: to = [<span class="py-string">'..'</span>] * (len(frm) - 1) + to</span>
<a id="line391"></a><span class="lineno">391</span><span class="line">   <span class="py-keyword">return</span> <span class="py-string">'/'</span>.join(to)</span>
<a id="line392"></a><span class="lineno">392</span>
<a id="line393"></a><span class="lineno">393</span><span class="line"><span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot.html#_convert_map">_convert_map</a>(input, output, base_url):</span>
<a id="line394"></a><span class="lineno">394</span><span class="line">   <span class="py-string">&quot;&quot;&quot;convert map generated from Dot to a html region map.</span></span>
<a id="line395"></a><span class="lineno">395</span><span class="line"><span class="py-string">   input and output are (open) streams&quot;&quot;&quot;</span></span>
<a id="line396"></a><span class="lineno">396</span>
<a id="line397"></a><span class="lineno">397</span><span class="line">   line = input.readline()</span>
<a id="line398"></a><span class="lineno">398</span><span class="line">   <span class="py-keyword">while</span> line:</span>
<a id="line399"></a><span class="lineno">399</span><span class="line">      line = line[:-1]</span>
<a id="line400"></a><span class="lineno">400</span><span class="line">      <span class="py-keyword">if</span> line[0:4] == <span class="py-string">&quot;rect&quot;</span>:</span>
<a id="line401"></a><span class="lineno">401</span><span class="line">         url, x1y1, x2y2 = line[4:].split()</span>
<a id="line402"></a><span class="lineno">402</span><span class="line">         x1, y1 = x1y1.split(<span class="py-string">','</span>)</span>
<a id="line403"></a><span class="lineno">403</span><span class="line">         x2, y2 = x2y2.split(<span class="py-string">','</span>)</span>
<a id="line404"></a><span class="lineno">404</span><span class="line">         output.write(<span class="py-string">'&lt;area alt=&quot;'</span>+url+<span class="py-string">'&quot; href=&quot;'</span> + _rel(base_url, url) + <span class="py-string">'&quot; shape=&quot;rect&quot; coords=&quot;'</span>)</span>
<a id="line405"></a><span class="lineno">405</span><span class="line">         output.write(str(x1) + <span class="py-string">&quot;, &quot;</span> + str(y1) + <span class="py-string">&quot;, &quot;</span> + str(x2) + <span class="py-string">&quot;, &quot;</span> + str(y2) + <span class="py-string">'&quot; /&gt;\n'</span>)</span>
<a id="line406"></a><span class="lineno">406</span><span class="line">      line = input.readline()</span>
<a id="line407"></a><span class="lineno">407</span>
<a id="line408"></a><span class="lineno">408</span><span class="line"><span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot.html#_format">_format</a>(input, output, format):</span>
<a id="line409"></a><span class="lineno">409</span>
<a id="line410"></a><span class="lineno">410</span><span class="line">   command = <span class="py-string">'dot -T%s -o &quot;%s&quot; &quot;%s&quot;'</span>%(format, output, input)</span>
<a id="line411"></a><span class="lineno">411</span><span class="line">   <span class="py-keyword">if</span> verbose: <span class="py-keyword">print</span> <span class="py-string">&quot;Dot Formatter: running command '&quot;</span> + command + <span class="py-string">&quot;'&quot;</span></span>
<a id="line412"></a><span class="lineno">412</span><span class="line">   <span class="py-keyword">try</span>:</span>
<a id="line413"></a><span class="lineno">413</span><span class="line">      system(command)</span>
<a id="line414"></a><span class="lineno">414</span><span class="line">   <span class="py-keyword">except</span> SystemError, e:</span>
<a id="line415"></a><span class="lineno">415</span><span class="line">      <span class="py-keyword">if</span> debug:</span>
<a id="line416"></a><span class="lineno">416</span><span class="line">         <span class="py-keyword">print</span> <span class="py-string">'failed to execute &quot;%s&quot;'</span>%command</span>
<a id="line417"></a><span class="lineno">417</span><span class="line">      <span class="py-keyword">raise</span> InvalidCommand, <span class="py-string">&quot;could not execute 'dot'&quot;</span></span>
<a id="line418"></a><span class="lineno">418</span>
<a id="line419"></a><span class="lineno">419</span><span class="line"><span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot.html#_format_png">_format_png</a>(input, output): _format(input, output, <span class="py-string">&quot;png&quot;</span>)</span>
<a id="line420"></a><span class="lineno">420</span>
<a id="line421"></a><span class="lineno">421</span><span class="line"><span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot.html#_format_html">_format_html</a>(input, output, base_url):</span>
<a id="line422"></a><span class="lineno">422</span><span class="line">   <span class="py-string">&quot;&quot;&quot;generate (active) image for html.</span></span>
<a id="line423"></a><span class="lineno">423</span><span class="line"><span class="py-string">   input and output are file names. If output ends</span></span>
<a id="line424"></a><span class="lineno">424</span><span class="line"><span class="py-string">   in '.html', its stem is used with an '.png' suffix for the</span></span>
<a id="line425"></a><span class="lineno">425</span><span class="line"><span class="py-string">   actual image.&quot;&quot;&quot;</span></span>
<a id="line426"></a><span class="lineno">426</span>
<a id="line427"></a><span class="lineno">427</span><span class="line">   <span class="py-keyword">if</span> output[-5:] == <span class="py-string">&quot;.html&quot;</span>: output = output[:-5]</span>
<a id="line428"></a><span class="lineno">428</span><span class="line">   _format_png(input, output + <span class="py-string">&quot;.png&quot;</span>)</span>
<a id="line429"></a><span class="lineno">429</span><span class="line">   _format(input, output + <span class="py-string">&quot;.map&quot;</span>, <span class="py-string">&quot;imap&quot;</span>)</span>
<a id="line430"></a><span class="lineno">430</span><span class="line">   prefix, name = os.path.split(output)</span>
<a id="line431"></a><span class="lineno">431</span><span class="line">   reference = name + <span class="py-string">&quot;.png&quot;</span></span>
<a id="line432"></a><span class="lineno">432</span><span class="line">   html = open_file(output + <span class="py-string">&quot;.html&quot;</span>)</span>
<a id="line433"></a><span class="lineno">433</span><span class="line">   html.write(<span class="py-string">'&lt;img alt=&quot;'</span>+name+<span class="py-string">'&quot; src=&quot;'</span> + reference + <span class="py-string">'&quot; hspace=&quot;8&quot; vspace=&quot;8&quot; border=&quot;0&quot; usemap=&quot;#'</span>)</span>
<a id="line434"></a><span class="lineno">434</span><span class="line">   html.write(name + <span class="py-string">&quot;_map\&quot; /&gt;\n&quot;</span>)</span>
<a id="line435"></a><span class="lineno">435</span><span class="line">   html.write(<span class="py-string">&quot;&lt;map name=\&quot;&quot;</span> + name + <span class="py-string">&quot;_map\&quot;&gt;&quot;</span>)</span>
<a id="line436"></a><span class="lineno">436</span><span class="line">   dotmap = open(output + <span class="py-string">&quot;.map&quot;</span>, <span class="py-string">&quot;r+&quot;</span>)</span>
<a id="line437"></a><span class="lineno">437</span><span class="line">   _convert_map(dotmap, html, base_url)</span>
<a id="line438"></a><span class="lineno">438</span><span class="line">   dotmap.close()</span>
<a id="line439"></a><span class="lineno">439</span><span class="line">   os.remove(output + <span class="py-string">&quot;.map&quot;</span>)</span>
<a id="line440"></a><span class="lineno">440</span><span class="line">   html.write(<span class="py-string">&quot;&lt;/map&gt;\n&quot;</span>)</span>
<a id="line441"></a><span class="lineno">441</span>
<a id="line442"></a><span class="lineno">442</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/Formatter.html">Formatter</a>(Processor):</span>
<a id="line443"></a><span class="lineno">443</span><span class="line">   <span class="py-string">&quot;&quot;&quot;The Formatter class acts merely as a frontend to</span></span>
<a id="line444"></a><span class="lineno">444</span><span class="line"><span class="py-string">   the various InheritanceGenerators&quot;&quot;&quot;</span></span>
<a id="line445"></a><span class="lineno">445</span>
<a id="line446"></a><span class="lineno">446</span><span class="line">   title = Parameter(<span class="py-string">'Inheritance Graph'</span>, <span class="py-string">'the title of the graph'</span>)</span>
<a id="line447"></a><span class="lineno">447</span><span class="line">   type = Parameter(<span class="py-string">'class'</span>, <span class="py-string">'type of graph (one of &quot;file&quot;, &quot;class&quot;, &quot;single&quot;'</span>)</span>
<a id="line448"></a><span class="lineno">448</span><span class="line">   hide_operations = Parameter(True, <span class="py-string">'hide operations'</span>)</span>
<a id="line449"></a><span class="lineno">449</span><span class="line">   hide_attributes = Parameter(True, <span class="py-string">'hide attributes'</span>)</span>
<a id="line450"></a><span class="lineno">450</span><span class="line">   show_aggregation = Parameter(False, <span class="py-string">'show aggregation'</span>)</span>
<a id="line451"></a><span class="lineno">451</span><span class="line">   bgcolor = Parameter(None, <span class="py-string">'background color for nodes'</span>)</span>
<a id="line452"></a><span class="lineno">452</span><span class="line">   format = Parameter(<span class="py-string">'ps'</span>, <span class="py-string">'Generate output in format &quot;dot&quot;, &quot;ps&quot;, &quot;png&quot;, &quot;svg&quot;, &quot;gif&quot;, &quot;map&quot;, &quot;html&quot;'</span>)</span>
<a id="line453"></a><span class="lineno">453</span><span class="line">   layout = Parameter(<span class="py-string">'vertical'</span>, <span class="py-string">'Direction of graph'</span>)</span>
<a id="line454"></a><span class="lineno">454</span><span class="line">   prefix = Parameter(None, <span class="py-string">'Prefix to strip from all class names'</span>)</span>
<a id="line455"></a><span class="lineno">455</span><span class="line">   toc_in = Parameter([], <span class="py-string">'list of table of content files to use for symbol lookup'</span>)</span>
<a id="line456"></a><span class="lineno">456</span><span class="line">   base_url = Parameter(None, <span class="py-string">'base url to use for generated links'</span>)</span>
<a id="line457"></a><span class="lineno">457</span>
<a id="line458"></a><span class="lineno">458</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dot/Formatter.html#process">process</a>(self, ir, **kwds):</span>
<a id="line459"></a><span class="lineno">459</span><span class="line">      <span class="py-keyword">global</span> verbose, debug</span>
<a id="line460"></a><span class="lineno">460</span>
<a id="line461"></a><span class="lineno">461</span><span class="line">      self.set_parameters(kwds)</span>
<a id="line462"></a><span class="lineno">462</span><span class="line">      <span class="py-keyword">if</span> self.bgcolor:</span>
<a id="line463"></a><span class="lineno">463</span><span class="line">         bgcolor = normalize(self.bgcolor)</span>
<a id="line464"></a><span class="lineno">464</span><span class="line">         <span class="py-keyword">if</span> <span class="py-keyword">not</span> bgcolor:</span>
<a id="line465"></a><span class="lineno">465</span><span class="line">            <span class="py-keyword">raise</span> InvalidArgument(<span class="py-string">'bgcolor=%s'</span>%repr(self.bgcolor))</span>
<a id="line466"></a><span class="lineno">466</span><span class="line">         <span class="py-keyword">else</span>:</span>
<a id="line467"></a><span class="lineno">467</span><span class="line">            self.bgcolor = bgcolor</span>
<a id="line468"></a><span class="lineno">468</span>
<a id="line469"></a><span class="lineno">469</span><span class="line">      self.ir = self.merge_input(ir)</span>
<a id="line470"></a><span class="lineno">470</span><span class="line">      verbose = self.verbose</span>
<a id="line471"></a><span class="lineno">471</span><span class="line">      debug = self.debug</span>
<a id="line472"></a><span class="lineno">472</span>
<a id="line473"></a><span class="lineno">473</span><span class="line">      formats = {<span class="py-string">'dot'</span> : <span class="py-string">'dot'</span>,</span>
<a id="line474"></a><span class="lineno">474</span><span class="line">                 <span class="py-string">'ps'</span> : <span class="py-string">'ps'</span>,</span>
<a id="line475"></a><span class="lineno">475</span><span class="line">                 <span class="py-string">'png'</span> : <span class="py-string">'png'</span>,</span>
<a id="line476"></a><span class="lineno">476</span><span class="line">                 <span class="py-string">'gif'</span> : <span class="py-string">'gif'</span>,</span>
<a id="line477"></a><span class="lineno">477</span><span class="line">                 <span class="py-string">'svg'</span> : <span class="py-string">'svg'</span>,</span>
<a id="line478"></a><span class="lineno">478</span><span class="line">                 <span class="py-string">'map'</span> : <span class="py-string">'imap'</span>,</span>
<a id="line479"></a><span class="lineno">479</span><span class="line">                 <span class="py-string">'html'</span> : <span class="py-string">'html'</span>}</span>
<a id="line480"></a><span class="lineno">480</span>
<a id="line481"></a><span class="lineno">481</span><span class="line">      <span class="py-keyword">if</span> formats.has_key(self.format): format = formats[self.format]</span>
<a id="line482"></a><span class="lineno">482</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line483"></a><span class="lineno">483</span><span class="line">         <span class="py-keyword">print</span> <span class="py-string">&quot;Error: Unknown format. Available formats are:&quot;</span>,</span>
<a id="line484"></a><span class="lineno">484</span><span class="line">         <span class="py-keyword">print</span> <span class="py-string">', '</span>.join(formats.keys())</span>
<a id="line485"></a><span class="lineno">485</span><span class="line">         <span class="py-keyword">return</span> self.ir</span>
<a id="line486"></a><span class="lineno">486</span>
<a id="line487"></a><span class="lineno">487</span><span class="line">      <span class="py-comment"># we only need the toc if format=='html'</span></span>
<a id="line488"></a><span class="lineno">488</span><span class="line">      <span class="py-keyword">if</span> format == <span class="py-string">'html'</span>:</span>
<a id="line489"></a><span class="lineno">489</span><span class="line">         <span class="py-comment"># beware: HTML.Fragments.ClassHierarchyGraph sets self.toc !!</span></span>
<a id="line490"></a><span class="lineno">490</span><span class="line">         toc = getattr(self, <span class="py-string">'toc'</span>, TOC.TOC(TOC.Linker()))</span>
<a id="line491"></a><span class="lineno">491</span><span class="line">         <span class="py-keyword">for</span> t <span class="py-keyword">in</span> self.toc_in: toc.load(t)</span>
<a id="line492"></a><span class="lineno">492</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line493"></a><span class="lineno">493</span><span class="line">         toc = None</span>
<a id="line494"></a><span class="lineno">494</span>
<a id="line495"></a><span class="lineno">495</span><span class="line">      head, tail = os.path.split(self.output)</span>
<a id="line496"></a><span class="lineno">496</span><span class="line">      tmpfile = os.path.join(head, quote_name(tail)) + <span class="py-string">&quot;.dot&quot;</span></span>
<a id="line497"></a><span class="lineno">497</span><span class="line">      <span class="py-keyword">if</span> self.verbose: <span class="py-keyword">print</span> <span class="py-string">&quot;Dot Formatter: Writing dot file...&quot;</span></span>
<a id="line498"></a><span class="lineno">498</span><span class="line">      dotfile = open_file(tmpfile)</span>
<a id="line499"></a><span class="lineno">499</span><span class="line">      dotfile.write(<span class="py-string">&quot;digraph \&quot;%s\&quot; {\n&quot;</span>%(self.title))</span>
<a id="line500"></a><span class="lineno">500</span><span class="line">      <span class="py-keyword">if</span> self.layout == <span class="py-string">'horizontal'</span>:</span>
<a id="line501"></a><span class="lineno">501</span><span class="line">         dotfile.write(<span class="py-string">'rankdir=&quot;LR&quot;;\n'</span>)</span>
<a id="line502"></a><span class="lineno">502</span><span class="line">         dotfile.write(<span class="py-string">'ranksep=&quot;1.0&quot;;\n'</span>)</span>
<a id="line503"></a><span class="lineno">503</span><span class="line">      dotfile.write(<span class="py-string">&quot;node[shape=record, fontsize=10, height=0.2, width=0.4, color=black]\n&quot;</span>)</span>
<a id="line504"></a><span class="lineno">504</span><span class="line">      <span class="py-keyword">if</span> self.type == <span class="py-string">'single'</span>:</span>
<a id="line505"></a><span class="lineno">505</span><span class="line">         generator = SingleInheritanceGenerator(dotfile, self.layout,</span>
<a id="line506"></a><span class="lineno">506</span><span class="line">                                                <span class="py-keyword">not</span> self.hide_operations,</span>
<a id="line507"></a><span class="lineno">507</span><span class="line">                                                <span class="py-keyword">not</span> self.hide_attributes,</span>
<a id="line508"></a><span class="lineno">508</span><span class="line">                                                -1, self.ir.asg.types,</span>
<a id="line509"></a><span class="lineno">509</span><span class="line">                                                toc, self.prefix, False,</span>
<a id="line510"></a><span class="lineno">510</span><span class="line">                                                self.bgcolor)</span>
<a id="line511"></a><span class="lineno">511</span><span class="line">      <span class="py-keyword">elif</span> self.type == <span class="py-string">'class'</span>:</span>
<a id="line512"></a><span class="lineno">512</span><span class="line">         generator = InheritanceGenerator(dotfile, self.layout,</span>
<a id="line513"></a><span class="lineno">513</span><span class="line">                                          <span class="py-keyword">not</span> self.hide_operations,</span>
<a id="line514"></a><span class="lineno">514</span><span class="line">                                          <span class="py-keyword">not</span> self.hide_attributes,</span>
<a id="line515"></a><span class="lineno">515</span><span class="line">                                          self.show_aggregation,</span>
<a id="line516"></a><span class="lineno">516</span><span class="line">                                          toc, self.prefix, False,</span>
<a id="line517"></a><span class="lineno">517</span><span class="line">                                          self.bgcolor)</span>
<a id="line518"></a><span class="lineno">518</span><span class="line">      <span class="py-keyword">elif</span> self.type == <span class="py-string">'file'</span>:</span>
<a id="line519"></a><span class="lineno">519</span><span class="line">         generator = FileDependencyGenerator(dotfile, self.layout, self.bgcolor)</span>
<a id="line520"></a><span class="lineno">520</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line521"></a><span class="lineno">521</span><span class="line">         sys.stderr.write(<span class="py-string">&quot;Dot: unknown type\n&quot;</span>);</span>
<a id="line522"></a><span class="lineno">522</span>
<a id="line523"></a><span class="lineno">523</span>
<a id="line524"></a><span class="lineno">524</span><span class="line">      <span class="py-keyword">if</span> self.type == <span class="py-string">'file'</span>:</span>
<a id="line525"></a><span class="lineno">525</span><span class="line">         <span class="py-keyword">for</span> f <span class="py-keyword">in</span> self.ir.files.values():</span>
<a id="line526"></a><span class="lineno">526</span><span class="line">            generator.visit_file(f)</span>
<a id="line527"></a><span class="lineno">527</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line528"></a><span class="lineno">528</span><span class="line">         <span class="py-keyword">for</span> d <span class="py-keyword">in</span> self.ir.asg.declarations:</span>
<a id="line529"></a><span class="lineno">529</span><span class="line">            d.accept(generator)</span>
<a id="line530"></a><span class="lineno">530</span><span class="line">      dotfile.write(<span class="py-string">&quot;}\n&quot;</span>)</span>
<a id="line531"></a><span class="lineno">531</span><span class="line">      dotfile.close()</span>
<a id="line532"></a><span class="lineno">532</span><span class="line">      <span class="py-keyword">if</span> format == <span class="py-string">&quot;dot&quot;</span>:</span>
<a id="line533"></a><span class="lineno">533</span><span class="line">         os.rename(tmpfile, self.output)</span>
<a id="line534"></a><span class="lineno">534</span><span class="line">      <span class="py-keyword">elif</span> format == <span class="py-string">&quot;png&quot;</span>:</span>
<a id="line535"></a><span class="lineno">535</span><span class="line">         _format_png(tmpfile, self.output)</span>
<a id="line536"></a><span class="lineno">536</span><span class="line">         os.remove(tmpfile)</span>
<a id="line537"></a><span class="lineno">537</span><span class="line">      <span class="py-keyword">elif</span> format == <span class="py-string">&quot;html&quot;</span>:</span>
<a id="line538"></a><span class="lineno">538</span><span class="line">         _format_html(tmpfile, self.output, self.base_url)</span>
<a id="line539"></a><span class="lineno">539</span><span class="line">         os.remove(tmpfile)</span>
<a id="line540"></a><span class="lineno">540</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line541"></a><span class="lineno">541</span><span class="line">         _format(tmpfile, self.output, format)</span>
<a id="line542"></a><span class="lineno">542</span><span class="line">         os.remove(tmpfile)</span>
<a id="line543"></a><span class="lineno">543</span>
<a id="line544"></a><span class="lineno">544</span><span class="line">      <span class="py-keyword">return</span> self.ir</span>
<a id="line545"></a><span class="lineno">545</span>
<a id="line546"></a><span class="lineno">546</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
